"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var DocNodeLeaf_1 = require("./DocNodeLeaf");
var StringChecks_1 = require("../parser/StringChecks");
/**
 * Represents a TSDoc block tag such as `@param` or `@public`.
 */
var DocBlockTag = /** @class */ (function (_super) {
    __extends(DocBlockTag, _super);
    /**
     * Don't call this directly.  Instead use {@link TSDocParser}
     * @internal
     */
    function DocBlockTag(parameters) {
        var _this = _super.call(this, parameters) || this;
        /** {@inheritDoc} */
        _this.kind = "BlockTag" /* BlockTag */;
        return _this;
    }
    Object.defineProperty(DocBlockTag.prototype, "tagName", {
        /**
         * The TSDoc tag name.  TSDoc tag names start with an at-sign ("@") followed
         * by ASCII letters using "camelCase" capitalization.
         */
        get: function () {
            return this._tagName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocBlockTag.prototype, "tagNameWithUpperCase", {
        /**
         * The TSDoc tag name in all capitals, which is used for performing
         * case-insensitive comparisons or lookups.
         */
        get: function () {
            return this._tagNameWithUpperCase;
        },
        enumerable: true,
        configurable: true
    });
    /** @override */
    DocBlockTag.prototype.updateParameters = function (parameters) {
        StringChecks_1.StringChecks.validateTSDocTagName(parameters.tagName);
        _super.prototype.updateParameters.call(this, parameters);
        this._tagName = parameters.tagName;
        this._tagNameWithUpperCase = this.tagName.toUpperCase();
    };
    return DocBlockTag;
}(DocNodeLeaf_1.DocNodeLeaf));
exports.DocBlockTag = DocBlockTag;
//# sourceMappingURL=DocBlockTag.js.map