"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var DocNode_1 = require("./DocNode");
var DocParticle_1 = require("./DocParticle");
/**
 * Represents an HTML start tag, which may or may not be self-closing.
 *
 * Example: `<a href="#" />`
 */
var DocHtmlStartTag = /** @class */ (function (_super) {
    __extends(DocHtmlStartTag, _super);
    /**
     * Don't call this directly.  Instead use {@link TSDocParser}
     * @internal
     */
    function DocHtmlStartTag(parameters) {
        var _this = _super.call(this, parameters) || this;
        /** {@inheritDoc} */
        _this.kind = "HtmlStartTag" /* HtmlStartTag */;
        return _this;
    }
    Object.defineProperty(DocHtmlStartTag.prototype, "elementName", {
        /**
         * The HTML element name.
         */
        get: function () {
            return this._elementNameParticle.content;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocHtmlStartTag.prototype, "htmlAttributes", {
        /**
         * The HTML attributes belonging to this HTML element.
         */
        get: function () {
            return this._htmlAttributes;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocHtmlStartTag.prototype, "selfClosingTag", {
        /**
         * If true, then the HTML tag ends with "/>" instead of ">".
         */
        get: function () {
            return this._selfClosingTag;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocHtmlStartTag.prototype, "spacingAfterElementName", {
        /**
         * Explicit whitespace that a renderer should insert after the HTML element name.
         * If undefined, then the renderer can use a formatting rule to generate appropriate spacing.
         */
        get: function () {
            return this._elementNameParticle.spacingAfterContent;
        },
        enumerable: true,
        configurable: true
    });
    /** @override */
    DocHtmlStartTag.prototype.updateParameters = function (parameters) {
        _super.prototype.updateParameters.call(this, parameters);
        this._openingDelimiterParticle = new DocParticle_1.DocParticle({
            particleId: 'openingDelimiter',
            excerpt: parameters.openingDelimiterExcerpt,
            content: '<'
        });
        this._elementNameParticle = new DocParticle_1.DocParticle({
            particleId: 'elementName',
            excerpt: parameters.elementNameExcerpt,
            content: parameters.elementName,
            spacingAfterContent: parameters.spacingAfterElementName
        });
        this._htmlAttributes = parameters.htmlAttributes;
        this._selfClosingTag = parameters.selfClosingTag;
        this._closingDelimiterParticle = new DocParticle_1.DocParticle({
            particleId: 'closingDelimiter',
            excerpt: parameters.closingDelimiterExcerpt,
            content: parameters.selfClosingTag ? '/>' : '>'
        });
    };
    /**
     * {@inheritDoc}
     * @override
     */
    DocHtmlStartTag.prototype.getChildNodes = function () {
        return [
            this._openingDelimiterParticle,
            this._elementNameParticle
        ].concat(this._htmlAttributes, [
            this._closingDelimiterParticle
        ]);
    };
    return DocHtmlStartTag;
}(DocNode_1.DocNode));
exports.DocHtmlStartTag = DocHtmlStartTag;
//# sourceMappingURL=DocHtmlStartTag.js.map