import { DocNodeKind, DocNode } from './DocNode';
import { DocInlineTag, IDocInlineTagParameters } from './DocInlineTag';
import { DocDeclarationReference } from './DocDeclarationReference';
/**
 * Constructor parameters for {@link DocInheritDocTag}.
 */
export interface IDocInheritDocTagParameters extends IDocInlineTagParameters {
    declarationReference?: DocDeclarationReference;
}
/**
 * Represents an `{@inheritDoc}` tag.
 */
export declare class DocInheritDocTag extends DocInlineTag {
    /** {@inheritDoc} */
    readonly kind: DocNodeKind;
    private _declarationReference;
    /**
     * Don't call this directly.  Instead use {@link TSDocParser}
     * @internal
     */
    constructor(parameters: IDocInheritDocTagParameters);
    /**
     * The declaration that the documentation will be inherited from.
     * If omitted, the documentation will be inherited from the parent class.
     */
    readonly declarationReference: DocDeclarationReference | undefined;
    /** @override */
    updateParameters(parameters: IDocInheritDocTagParameters): void;
    /**
     * {@inheritDoc}
     * @override
     */
    protected getChildNodesForContent(): ReadonlyArray<DocNode>;
}
