"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var DocNode_1 = require("./DocNode");
var DocInlineTag_1 = require("./DocInlineTag");
/**
 * Represents an `{@inheritDoc}` tag.
 */
var DocInheritDocTag = /** @class */ (function (_super) {
    __extends(DocInheritDocTag, _super);
    /**
     * Don't call this directly.  Instead use {@link TSDocParser}
     * @internal
     */
    function DocInheritDocTag(parameters) {
        var _this = _super.call(this, parameters) || this;
        /** {@inheritDoc} */
        _this.kind = "InheritDocTag" /* InheritDocTag */;
        return _this;
    }
    Object.defineProperty(DocInheritDocTag.prototype, "declarationReference", {
        /**
         * The declaration that the documentation will be inherited from.
         * If omitted, the documentation will be inherited from the parent class.
         */
        get: function () {
            return this._declarationReference;
        },
        enumerable: true,
        configurable: true
    });
    /** @override */
    DocInheritDocTag.prototype.updateParameters = function (parameters) {
        if (parameters.tagName.toUpperCase() !== '@INHERITDOC') {
            throw new Error('DocInheritDocTag requires the tag name to be "{@inheritDoc}"');
        }
        _super.prototype.updateParameters.call(this, parameters);
        this._declarationReference = parameters.declarationReference;
    };
    /**
     * {@inheritDoc}
     * @override
     */
    DocInheritDocTag.prototype.getChildNodesForContent = function () {
        if (this.tagContentParticle.excerpt) {
            // If the parser associated the inline tag input with the tagContentExcerpt (e.g. because
            // second stage parsing encountered an error), then fall back to the base class's representation
            return _super.prototype.getChildNodesForContent.call(this);
        }
        else {
            // Otherwise return the detailed structure
            return DocNode_1.DocNode.trimUndefinedNodes([
                this._declarationReference
            ]);
        }
    };
    return DocInheritDocTag;
}(DocInlineTag_1.DocInlineTag));
exports.DocInheritDocTag = DocInheritDocTag;
//# sourceMappingURL=DocInheritDocTag.js.map